unit selecte;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, checklst;

type
  Tfselecte = class(TForm)
    ListBox4: TListBox;
    ListBox1: TListBox;
    Label1: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn7: TBitBtn;
    Memo1: TMemo;
    Panel2: TPanel;
    RadioGroup3: TRadioGroup;
    SpeedButton1: TSpeedButton;
    ProgressBar1: TProgressBar;
    BitBtn6: TBitBtn;
    Label4: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    SaveDialog1: TSaveDialog;
    CheckListBox1: TCheckListBox;
    BitBtn4: TBitBtn;
    Edit2: TEdit;
    Label3: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    procedure go_sort(Sender: TObject);
    procedure init_active(Sender: TObject);
    procedure selecte_nb(Sender: TObject);
    procedure select_all(Sender: TObject);
    procedure sauve_sorted_sol(Sender: TObject);
    procedure selecte_syst(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure onclickradio3(Sender: TObject);
    procedure on_change_edit(Sender: TObject);
    procedure sortie(Sender: TObject);
//    procedure relit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fselecte: Tfselecte;

implementation

uses
unit1,mathhkl,unit3b ;

var
  nb_sol_crysfire_new             : integer;

{$R *.DFM}

procedure Tfselecte.go_sort(Sender: TObject);
//----------------------------------------
var
  nomf                  : textfile;
  i,j,k,no,ier          : integer;
  s,s1                  : string;
  x,y                   : array[1..5000] of real;
  indic                 : array[1..5000] of integer;
  liste                 : array[1..5000] of string[73];
  s73                   : string[73];
  x1,x2,rap             : real;
  maille                : tab_reel;
  i20,i20_max           : integer;
  wo                    : word;
  nb_sol_lim            : integer;

  dist,dist_min                       : real;
  nb_raies_obs_max,nb_raies_indx_min  : integer;
  nb_raies_obs_min,nb_raies_indx_max  : integer;
  n1,n2                               : integer;
  cel_depart                          : array[1..6] of real;
  systeme_old                         : string;
  label 1;

begin
  if (radiogroup3.itemindex = -1)then begin
    erreur('Select a sort criterion');
    exit;
  end;

  nb_sol_lim:=strtoint(edit2.text);
  if (nb_sol_lim > nb_sol_crysfire)then nb_sol_lim:=nb_sol_crysfire;

  speedbutton1.visible:=true;
  systeme_old:=systeme;
  for i:=1 to nb_sol_crysfire do indic[i]:=1;
  if (checklistbox1.state[0] = CbunChecked)then begin
    for i:=1 to nb_sol_lim do
    if(checklistbox1.state[crysum[i].no_syst] = CbUnChecked) then indic[i]:=0;
  end;

  nb_sol_crysfire_new:=0;
  case radiogroup3.ItemIndex of

//No
//--
    0: begin
          listbox1.Clear;
          for i:=0 to nb_sol_lim do begin
              if (i > 0) and (indic[i] = 0)then continue;
              listbox1.items.add(form1.listbox4.items[i]);
              if (i > 0)then nb_sol_crysfire_new:=nb_sol_crysfire_new+1;
              progressbar1.position:=round(100*i/nb_sol_lim);
         end;
        progressbar1.position:=0;
        end;

//FOM
//---
    1: begin
         for i:=1 to nb_sol_lim do begin
           liste[i]:=listbox4.items[i];
           s:=copy(liste[i],1,16);
           delete(s,1,8);
           s:=trim(s);
           val(s,y[i],ier);
           if (ier > 0)then begin
             erreur('conversion error');
             exit;
           end;
         end;
         listbox1.clear;
         for i:=1 to nb_sol_lim-1 do begin
           for j:=i+1 to nb_sol_lim do begin
             if (y[i] < y[j])then begin
               s73:=liste[i];
               liste[i]:=liste[j];
               liste[j]:=s73;
               x1:=y[i];
               y[i]:=y[j];
               y[j]:=x1;
             end;
           end;
           progressbar1.position:=round(100*i/nb_sol_lim);
         end;
          for i:=0 to nb_sol_lim do begin
              if (i > 0) and (indic[i] = 0)then continue;
              listbox1.items.add(form1.listbox4.items[i]);
              if (i > 0) then nb_sol_crysfire_new:=nb_sol_crysfire_new+1;
          end;
        progressbar1.position:=0;
       end;

//I/I20
//-----
    2: begin
         for i:=1 to nb_sol_lim do begin
           liste[i]:=listbox4.items[i];
           s:=copy(liste[i],1,8);
           delete(s,1,4);
           s:=trim(s);
           val(s,y[i],ier);
           if (ier > 0)then begin
             erreur('conversion error');
             exit;
           end;
         end;
         listbox1.clear;
         for i:=1 to nb_sol_lim-1 do begin
           for j:=i+1 to nb_sol_lim do begin
             if (y[i] < y[j])then begin
               s73:=liste[i];
               liste[i]:=liste[j];
               liste[j]:=s73;
               x1:=y[i];
               y[i]:=y[j];
               y[j]:=x1;
             end;
           end;
           progressbar1.position:=round(100*i/nb_sol_lim);
         end;
         for i:=0 to nb_sol_lim do begin
              if (i > 0) and (indic[i] = 0)then continue;
              listbox1.items.add(form1.listbox4.items[i]);
              if (i > 0)then nb_sol_crysfire_new:=nb_sol_crysfire_new+1;
         end;
        progressbar1.position:=0;
       end;
//Sort Chekcell
//-------------
       3: begin
           //screen.cursor:=crHourglass;
           //progressbar1.visible:=true;
           for i:=1 to nb_sol_lim do x[i]:=0;
           for i:=1 to nb_sol_lim do begin
              liste[i]:=crysum[i].liste;
              s:=liste[i];

//Sortie sur abort
              application.processmessages;
              if speedbutton1.Down then begin
                beep;
                wo:=messageDlg(' Do you want to stop the process?',
                mtConfirmation,mbYesNoCancel,0);
                if (wo= mryes)  then begin
                  speedbutton1.down:=false;
                  //screen.cursor:=crHourglass;
                  progressbar1.position:=0;
                  goto 1;
                end else begin
                  speedbutton1.down:=false;
                end;
              end;

//Calcul des raies indx
              if (i = 1)then i20_max:=crysum[i].i20;
              i20:=crysum[i].i20;
              systeme:=crysum[i].syst;
              if (systeme = 'CUBI')then groupe_espace:='P23';
              if (systeme = 'TETR')then groupe_espace:='P4';
              if (systeme = 'ORTH')then groupe_espace:='P222';
              if (systeme = 'HEXA')then groupe_espace:='P6';
              if (systeme = 'RHOM')then groupe_espace:='R3';
              if (systeme = 'MONO')then groupe_espace:='P2';
              if (systeme = 'TRIC')then groupe_espace:='P1';
              bravais:='P';
              indx; //provoque le clignotement du curseur
              progressbar1.position:=round(100*i/nb_sol_lim);

//recherche des raies calcules(indx) proches des raies dif (nombre = nb_raies_obs)
              nb_raies_obs:=0;
              for j:=1 to nb_raies_dif do begin
                 dist_min:=1000;
                 for k:=1 to nb_raies_indx do begin
                   if (raies_indx[k].ext = 1)then continue;
                   dist:=(theta_dif[j]-raies_indx[k].dtheta);
                   if (dist < -tolerance)then continue;
                   dist:=abs(dist);
                   if (dist < dist_min)then dist_min:=dist;
                 end;
                 if (dist_min > tolerance)then continue;
                 nb_raies_obs:=nb_raies_obs+1;
                 x[i]:=nb_raies_obs;
                 y[i]:=nb_raies_indx;
              end;
           end;
           screen.cursor:=crHourglass;

//Classement en x croissant
           for i:=1 to nb_sol_lim-1 do begin
             for j:=i+1 to nb_sol_lim do begin
               if (x[i] < x[j])then begin
                 s73:=liste[i];
                 liste[i]:=liste[j];
                 liste[j]:=s73;
                 k:=indic[i];
                 indic[i]:=indic[j];
                 indic[j]:=k;
                 x1:=x[i];
                 x[i]:=x[j];
                 x[j]:=x1;
                 x1:=y[i];
                 y[i]:=y[j];
                 y[j]:=x1;
               end;
             end;
           end;

           nb_raies_obs_max:=0;
           nb_raies_indx_max:=0;
           nb_raies_obs_min:=10000;
           nb_raies_indx_min:=10000;
           for i:=1 to nb_sol_lim do begin
             if (round(x[i]) > nb_raies_obs_max)then nb_raies_obs_max:=round(x[i]);
             if (round(x[i]) < nb_raies_obs_min)then nb_raies_obs_min:=round(x[i]);
             if (round(y[i]) < nb_raies_indx_min)then nb_raies_indx_min:=round(y[i]);
             if (round(y[i]) > nb_raies_indx_max)then nb_raies_indx_max:=round(y[i]);
           end;

//Ecriture dans listbox1
           j:=0;
           listbox1.clear;
           listbox1.items.add
           (' Nb I/I20  FOM   V/V1    a      b      c   alpha   beta   gamma    Vol.  Check Calc');
           for n1:=nb_raies_obs_max downto nb_raies_obs_min do begin
             for n2:=nb_raies_indx_min to nb_raies_indx_max do begin
               for i:=1 to nb_sol_lim do begin
                 if (indic[i] = 0)then continue;
                 if (round(x[i]) = n1) and (round(y[i]) = n2) then begin
                   s:=liste[i];
                   str(x[i]:5:0,s1);s:=s+s1;
                   str(y[i]:5:0,s1);s:=s+s1;
                   listbox1.Items.add(s);
                   j:=j+1;
                 end;
               end;
             end;
           end;
           nb_sol_crysfire_new:=j;
           screen.cursor:=crDefault;
           listbox4.itemindex:=1;
           form1.onclicklistbox4(sender);
           progressbar1.position:=0;
        end;
  end;
  beep;
  panel1.visible:=true;
  speedbutton1.visible:=false;
  exit;

1:  form1.reread(sender);
    panel1.visible:=false;
    speedbutton1.visible:=false;
    //progressbar1.visible:=false;
end;

procedure Tfselecte.init_active(Sender: TObject);
//---------------------------------------------
var
  i           : integer;
begin
  checkListBox1.state[0]:=cbChecked;
  //Checklistbox1.ItemIndex:=0;
  for i:=1 to 7 do checkListBox1.state[i]:=cbUnChecked;
  radiogroup3.itemindex:=0;
  label1.caption:='Crysfire Solutions. Nb: '+inttostr(nb_sol_crysfire);
  listbox4.Clear;
  listbox1.clear;
  listbox4.items.add(form1.listbox4.items[0]);
  for i:=1 to nb_sol_crysfire do listbox4.items.add(form1.listbox4.items[i]);
  edit2.text:=intToStr(nb_sol_crysfire);
  edit3.text:=edit2.text;
end;

procedure Tfselecte.selecte_nb(Sender: TObject);
//-------------------------------------------
var
  n,i           : integer;
begin
  if (edit1.text='')then begin
    //close;
    exit;
  end;
  n:=strtoint(edit1.text);
  if (n > nb_sol_crysfire)then n:=nb_sol_crysfire;
  nb_sol_crysfire:=n;
  form1.listbox4.clear;
  for i:=0 to n do form1.listbox4.Items.add(listbox1.items[i]);
  form1.Label56.caption:='Nb of select. sol :'+inttostr(n);
  panel1.visible:=false;
  form1.listbox4.itemindex:=1;
  form1.onclicklistbox4(Sender);
  form1.label56.caption:=
  'Nb of solutions after sorting: '+intToStr(nb_sol_crysfire);
  close;
end;

procedure Tfselecte.select_all(Sender: TObject);
//-----------------------------------------------
begin
  edit1.text:=inttostr(nb_sol_crysfire_new);
end;

//Ecriture fichier *.ckm
procedure Tfselecte.sauve_sorted_sol(Sender: TObject);
//----------------------------------------------------
var
  nomf              : textfile;
  nom_fichier,s     : string;
  n,i,j             : integer;
  w                 : word;
begin
  if (edit1.text='')then exit;
  n:=strtoint(edit1.text);
  if (n > nb_sol_crysfire)then n:=nb_sol_crysfire;
  //nb_sol_crysfire:=n;
  if Savedialog1.execute then begin
    nom_fichier:=Savedialog1.filename;
    if (pos('.ckm',nom_fichier) = 0 ) then nom_fichier:=nom_fichier+'.ckm';
    if FileExists(nom_fichier) then begin
        beep;
        w:=messageDlg('This file already exists. Do you want to continue?',
        mtConfirmation,mbYesNoCancel,0);
        if (w = mrNo) or (w = mrAbort) then exit;
    end;

//Ouverture du fichier  crer
    assignfile(nomf,nom_fichier);
    rewrite(nomf);
    for i:=1 to n do begin
      s:=listbox1.Items[i];
      cree_ligne_crysfire(s);
      writeln(nomf,s);
    end;
    closefile(nomf);
  end;
end;


procedure Tfselecte.selecte_syst(Sender: TObject);
//-------------------------------------------------
var
  i              : integer;
begin
  with checklistbox1 do begin
    if (itemindex = 0) then begin
      for i:=1 to 6 do state[i]:=cbunchecked;
      state[0]:=cbchecked;
    end else begin
      state[0]:=cbunchecked;
    end;
  end;
  fselecte.BitBtn4Click(Sender)
end;

procedure Tfselecte.BitBtn4Click(Sender: TObject);
//-----------------------------------------------
var
  i              : integer;
begin
  //form1.reread(Sender);
  fselecte.show;
  listbox4.Clear;
  listbox1.clear;
  listbox4.items.add(form1.listbox4.items[0]);
  for i:=1 to nb_sol_crysfire do listbox4.items.add(form1.listbox4.items[i]);
end;

procedure Tfselecte.onclickradio3(Sender: TObject);
//-------------------------------------------------
var
  i              : integer;
begin
  //form1.reread(Sender);
  fselecte.show;
  listbox4.Clear;
  listbox1.clear;
  listbox4.items.add(form1.listbox4.items[0]);
  for i:=1 to nb_sol_crysfire do listbox4.items.add(form1.listbox4.items[i]);
end;

procedure Tfselecte.on_change_edit(Sender: TObject);
//--------------------------------------------------
begin
  if (strtoint(edit1.text) > nb_sol_crysfire_new)
  then edit1.text:=inttostr(nb_sol_crysfire_new);
end;

procedure Tfselecte.sortie(Sender: TObject);
//-----------------------------------------
begin
  close;
end;


end.
