unit supple;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ColorBtns, ComCtrls;

type
  Tfsupple = class(TForm)
    ListBox4: TListBox;
    ListBox6: TListBox;
    ListBox2: TListBox;
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    Panel1: TPanel;
    Label6: TLabel;
    Edit4: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Edit6: TEdit;
    Edit8: TEdit;
    ListBox3: TListBox;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    Color95Button2: TColor95Button;
    Color95Button4: TColor95Button;
    Panel2: TPanel;
    SpeedButton2: TSpeedButton;
    Memo1: TMemo;
    Color95Button6: TColor95Button;
    procedure go_calcul(Sender: TObject);
    procedure init(Sender: TObject);
    procedure edite_listbox2(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure selecte_sol(Sender: TObject);
    procedure add_to_summary(Sender: TObject);
    procedure init_creation(Sender: TObject);
    procedure click_fenetre2(Sender: TObject);
    procedure fitte_tolerance(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fsupple: Tfsupple;
  nb_sol,i20                             : integer;
  fom_sol                                : real;

implementation

{$R *.DFM}
uses
  mathhkl,unit3b, unit3, truecell, Unit1, unit9;

  var
  tab_maille                                       : array[1..5000,1..3] of real;
  nb_mailles,nb_lignes                             : integer;
  cel_old                                          : array[1..6] of real;
  indexe_min,no_fenetre                            : integer;

procedure affiche_groupes;
//------------------------
var
  s,s1                    : string;
  nomf                    : TextFile;
begin
  s1:=repertoire_origine+'\'+systeme+'.pos';
  if (systeme ='QUAD')then s1:=repertoire_origine+'\'+'TETR.pos';
  AssignFile(nomf,s1);
  reset(nomf);
  nb_groupes:=0;
  fsupple.listbox1.clear;
  while not (eof(nomf)) do begin
    readln(nomf,s);
    s:=TrimRight(s);
    if(length(s) = 0)then begin
      readln(nomf,s);
      s:=trim(s);
      fsupple.listbox1.items.add(s);
      if(s <> '')then nb_groupes:=nb_groupes+1;
    end;
  end;
  closeFile(nomf);
end;

procedure Tfsupple.go_calcul(Sender: TObject);
//-------------------------------------------
type type_test =record
             count_ind,count_calc,no_sum : integer;
           end;

var
  s,s1,s_ligne                                           : string;
  n,no,k,i_raie,ier,i,j,i_groupe,h,l,nb_indx_crsf,
  nb_raies_ind_max,nb_raies_calc_min,isol,premier        : integer;
  maille                                                 : tab_reel;
  ang_calc,ang_obs                                       : real;
  dist,dist_min                                          : real;
  nomf                                                   : TextFile;
  test                                                   : array[1..50000] of ^type_test;
  sigma                                                  : double;
  wo                                                     : word;
  n_index,n_index_max,n_calc,n_calc_min,
  nb_raies_calc                                          : integer;
  i_setting,nb_setting,no_test,no_test1,numero           : integer;
//  no_total,no_boucle                                     : real;
const
   Osetting  : array[1..6] of string[4]= ('abc','cab','bca','a-cb','ba-c','-cba');

  label  1;
//  label  2;

begin
  screen.cursor:=crHourGlass;
  listbox2.clear;
  indexe_min:=strtoint(edit6.text);
  s:=edit4.text;
  val(s,tolerance,i);
  if (i > 0)then begin
    erreur('Tolerance error');
    edit4.setfocus;
    exit;
  end;
  for i:=1 to 6 do cel_old[i]:=cel[i];
   listbox2.items.clear;
  nb_lignes:=0;
  nb_mailles:=0;
  no_test:=0;
  s:=' Nb I/I20  FOM   V/V1    a      b      c   alpha   beta   gamma    Vol.'+
  ' Sp.Group Setting    Sigma    Checked  Calc.  Truecell Nb';
  listbox3.clear;
  listbox3.items.add(s);
  listbox3.refresh;

//boucle sur les solutions
    for isol:=1 to nb_sol do begin
      s:=listbox4.items[isol-1];
      if (s = '')then break;
      s:=copy(s,1,73);
      s_ligne:=copy(s,5,length(s)-4);
      dec(s,maille,no,ier);
      if (ier <> 0)then begin
        erreur('Decoding cell error at '+s);
        exit;
      end;
      for i:=1 to 6 do cel[i]:=maille[i+4];
      for i:=1 to 6 do maille[i]:=cel[i];
      
      if (cel[4] > 179) or (cel[5] > 179) or (cel[6] > 179)then begin
        erreur(inttostr(isol)+' Cell error at '+s);
        exit;
      end;

      quel_systeme2(maille);
      affiche_groupes;

//boucle sur les groupes
      for i_groupe:=1 to nb_groupes do begin

//Click sur bouton Abort
        application.processmessages;
        if speedbutton1.Down then begin
          beep;
          wo:=messageDlg(' Do you want to abort the process?',
          mtConfirmation,mbYesNoCancel,0);
          if (wo= mryes)  then begin
             listbox2.items.add('Stopped by the user');
             nb_lignes:=nb_lignes+1;
             screen.cursor:=crdefault;
             speedbutton1.down:=false;
             if (no_test > 0)then for l:=1 to no_test do dispose(test[l]);
             speedbutton2.visible:=false;
             exit;
          end else begin
            speedbutton1.down:=false;
            fsupple.visible:=true;
          end;
        end;

        listbox1.itemIndex:=i_groupe-1;
        s:=listbox1.items[i_groupe-1];
        if(s = '')then break;
        groupe_espace:=uppercase(s);
        if (systeme = 'TRIC') and (groupe_espace = 'P1')then continue;
        bravais:=copy(groupe_espace,1,1);
        if(systeme = 'RHOM')then bravais:='P';
        if (bravais = 'N')then bravais:='P'; //No. Ext
        indx;
        Nb_setting:=1;
        if (systeme = 'ORTH') and  (nb_ligne_code > 0) then nb_setting:=6;
        premier:=1;
        for i_setting:=1 to nb_setting do begin
          for i:=1 to 3 do
          for j:=1 to 3 do r[i,j]:=Oabc[i_setting,i,j];
          nb_raies_calc:=0;
          for j:=1 to nb_raies_indx do begin
            listbox4.itemindex:=isol-1;
            with raies_indx[j] do begin
              h:=r[1,1]*hr+r[1,2]*kr+r[1,3]*lr;
              k:=r[2,1]*hr+r[2,2]*kr+r[2,3]*lr;
              l:=r[3,1]*hr+r[3,2]*kr+r[3,3]*lr;
              extinc(h,k,l,ier);
              ext:=ier;
              if (ier = 1) and (bravais = 'R')then begin
                extinc(k,h,l,ier);
                ext:=ier;
              end;
              if (ier = 0)then nb_raies_calc:=nb_raies_calc+1;
            end;
          end;

//recherche des raies calcules(indx) proches des raies dif
          nb_raies_obs:=0;
          for j:=1 to nb_raies_dif do begin
            dist_min:=1000;
            i_raie:=1;
            for k:=1 to nb_raies_indx do begin
              if (raies_indx[k].ext = 1)then continue;
              dist:=(theta_dif[j]-raies_indx[k].dtheta);
              if (dist < -tolerance)then continue;
              dist:=abs(dist);
              if (dist < dist_min)then begin
                ang_calc:=raies_indx[k].dtheta;
                ang_obs:=theta_dif[j];
                dist_min:=dist;
                i_raie:=k;
              end;
            end;
            if (dist_min > tolerance)then continue;
            nb_raies_obs:=nb_raies_obs+1;
            if (nb_raies_obs >= 1000)then begin
              erreur('Too many reflections (> 1000)');
              nb_raies_obs:=nb_raies_obs-1;
              screen.cursor:=crdefault;
              goto 1;
            end;
            h_obs[nb_raies_obs]:=raies_indx[i_raie].hr;
            k_obs[nb_raies_obs]:=raies_indx[i_raie].kr;
            l_obs[nb_raies_obs]:=raies_indx[i_raie].lr;
            dtheta_obs[nb_raies_obs]:=ang_obs;
            dtheta_obs_cor[nb_raies_obs]:=ang_obs;
            dtheta_calc[nb_raies_obs]:=ang_calc;
            numero4:=j;
          end;
//Calcul de sigma
1:        if (nb_raies_obs < indexe_min)then continue;
          no_test:=no_test+1;
          if(no_test > 50000)then begin
            erreur('Too many test lines (> 50000)');
            screen.cursor:=crDefault;
            if (no_test > 0)then for l:=1 to no_test do dispose(test[l]);
            exit;
          end;
          new(test[no_test]);
          with test[no_test]^ do begin
            no_sum:=isol;
            count_ind:=nb_raies_obs;
            count_calc:=nb_raies_calc;
          end;
          n:=0;
          sigma:=0;
          for i:=1 to nb_raies_dif do begin
            ang_obs:=theta_dif[i];
            k:=0;
            for j:=1 to nb_raies_obs do begin
              if (abs(ang_obs-dtheta_calc[j]) < tolerance)then begin
                k:=j;
                n:=n+1;
                sigma:=sigma+sqr(ang_obs-dtheta_calc[j]);
                break;
              end;
            end;
          end;
//Ecriture dans listbox2 //Solution
          s:=copy(listbox4.items[isol-1],1,73);
//systeme
          //s:=s+' '+systeme;
//groupe
          s1:=listbox1.Items[i_groupe-1];
          if (length(s1) < 8)then for k:=length(s1) to 8  do s1:=s1+' ';
          s:=s+'  '+s1;
          l:=length(s);
//setting
          if (systeme = 'ORTH')then begin
            s1:=' '+Osetting[i_setting];
          end else s1:=' ';
          if (length(s1) < 6)then for k:=length(s1) to 8  do s1:=s1+' ';
          s:=s+s1;
//sigma
          str(sigma:8:5,s1);
          s:=s+s1+'  ';
//nb de raies indexes
          str(n:5,s1);
          s:=s+s1+'  ';
//nb de raies calcules
          str(nb_raies_calc:5,s1);
          s:=s+s1;
//si c'est le premier setting du groupe (premier = 1), on crit tout, sinon on efface 74 car.
          if (premier > 1)then for k:=1 to 74 do s[k]:=' ';
          if (premier = 1)then no_test1:=no_test;
          test[no_test]^.no_sum:=no_test1;
//ecriture
          str(isol:4,s1);
          nb_lignes:=nb_lignes+1;
          (*str(nb_lignes:7,s1);s:=s+s1;
          s:=s+s1;*)
          listbox2.items.add(s);
          listbox2.itemindex:=nb_lignes-1;
          premier:=premier+1;
        end
      end; //i_groupe
    end;   //i_sol

  listbox2.items.add(' ');
  listbox2.items.add('Estimated best solution(s):');
  nb_lignes:=nb_lignes+2;
  listbox4.itemindex:=isol-1;

//Meilleure solution
  if (no_test = 0)then begin
       listbox2.items.add('No solution. Modify the starting conditions');
       nb_lignes:=nb_lignes+1;
  end else begin
      nb_raies_ind_max:=0;
      for i:=1 to no_test do begin
        if (test[i]^.count_ind > nb_raies_ind_max)then
        nb_raies_ind_max:=test[i]^.count_ind;
      end;
      nb_raies_calc_min:=1000000;
      for i:=1 to no_test do begin
        if (test[i].count_ind = nb_raies_ind_max)then begin
          if (test[i]^.count_calc < nb_raies_calc_min)then
          nb_raies_calc_min:=test[i]^.count_calc;
        end;
      end;
      for i:=1 to no_test do begin
        if (test[i]^.count_ind = nb_raies_ind_max) and
          (test[i]^.count_calc = nb_raies_calc_min) then begin
          s:=listbox2.items[i-1];
          delete(s,1,74);
          s:=copy(listbox2.items[test[i]^.no_sum-1],1,74)+s;
          listbox2.items.add(s);
          nb_lignes:=nb_lignes+1;
          ier:=0;
        end;
      end;
  end;
  listbox2.itemindex:=nb_lignes-1;
  for i:=1 to no_test do dispose(test[i]);
  beep;

 //Affichage du dernier groupe, dernire solution
  for i:=1 to 6 do cel[i]:=cel_old[i];
    for i:=1 to nb_sol_crysfire do crysum[i].no_truecell:=0;

  speedbutton2.visible:=true;
  panel2.visible:=true;
  screen.cursor:=crDefault;
  beep;
end;

procedure Tfsupple.init(Sender: TObject);
//-------------------------------------
  var
    s,s1               : string;
    i,j,k,nb_sum,n     : integer;
begin
  s:=' Nb I/I20  FOM   V/V1    a      b      c   alpha   beta   gamma    Vol.  ';
  listbox6.clear;
  listbox6.items.add(s);

  edit8.text:=inttostr(nb_raies_dif);
  if (edit6.text = '')then edit6.text:=edit8.text;
  if (edit4.text = '')then begin
    str(tolerance:6:2,s);
    edit4.text:=s;
  end;
  if (edit6.text = '')then edit6.text:=edit8.text;

//Ecriture de la liste des solutions Truecell dans supple.listbox4

end;

procedure Tfsupple.edite_listbox2(Sender: TObject);
//-----------------------------------------------
var
    CmdFile      : Pchar;
    iwin,i       : integer;
    nomf         : TextFile;
begin
  if (listbox2.items.count = 0)then exit;
  assignFile(nomf,'listbox2.tmp');
  rewrite(nomf);
  writeln(nomf,extractFilename(nom_fichier_sum));
  writeln(nomf,listbox3.items[0]);
  for i:=1 to nb_lignes do writeln(nomf,listbox2.items[i-1]);
  CloseFile(nomf);
  CmdFile:='write.exe listbox2.tmp';
  iwin:=WinExec(CmdFile,5);
end;

procedure Tfsupple.SpeedButton1Click(Sender: TObject);
//--------------------------------------------------
begin
//  close;
end;

procedure Tfsupple.selecte_sol(Sender: TObject);
//----------------------------------------------
begin
 //speedbutton2.visible:=true;
 speedbutton2.down:=false;
 speedbutton2.font.color:=clblack;
 no_fenetre:=4;
end;

procedure Tfsupple.add_to_summary(Sender: TObject);
//------------------------------------------------
var
  s,s1              : string;
  s63,t63           : string[63];
  i,j,k,nb_sum ,n   : integer;
  no_sol_truecell   : array[1..1000] of integer;
  label 1;
begin
    screen.cursor:=crhourglass;
    speedbutton2.down:=false;
    n:=crysum_truecell[listbox4.itemindex+1].num;

//La solution figure dj dans la liste Summary Crysfire
    if (n > 0)then begin
      //recherche de la solution No n dans la liste
      for j:=1 to nb_sol_crysfire do begin
        s:=copy(form1.listbox4.items[j],1,4);
        if (n = strtoint(s))then begin
          nb_sum:=j;
          s1:=form1.listbox4.items[nb_sum];
          break;
        end;
      end;
      crysum[1]:=crysum[nb_sum];
      crysum[1].no_truecell:=listbox4.itemindex+1;
      for j:=nb_sum downto 2 do begin
         form1.listbox4.items[j]:=form1.listbox4.items[j-1];
         crysum[j]:=crysum[j-1];
      end;
      form1.listbox4.items[1]:=s1;

//La solution est nouvelle
    end else begin
    //a-t-elle t dj dplace?
      for i:=1 to nb_sol_crysfire do begin
         if (crysum[i].no_truecell = listbox4.itemindex+1)then begin
           erreur('This cell was already moved onto the summary list)');
           goto 1;
         end;
      end;
      nb_sol_crysfire:=nb_sol_crysfire+1;
      form1.listbox4.items.add(' ');
      for j:=nb_sol_crysfire downto 2 do begin
        form1.listbox4.items[j]:=form1.listbox4.items[j-1];
        crysum[j]:=crysum[j-1];
      end;
      s1:=fsupple.listbox4.items[listbox4.itemindex];
      form1.listbox4.items[1]:=s1;
      crysum[1]:=crysum_truecell[listbox4.itemindex];
      crysum[1].no_truecell:=listbox4.itemindex+1;

    end;
    ftruecell.listbox1.clear;
    for i:=0 to nb_sol_crysfire do ftruecell.ListBox1.Items.add(form1.listbox4.items[i]);
1:
    beep;
    speedbutton2.down:=true;
    speedbutton2.font.color:=clgray;
    screen.cursor:=crdefault;
end;

procedure Tfsupple.init_creation(Sender: TObject);
//------------------------------------------------
begin
  speedbutton2.Font.color:=clgray;
end;

procedure Tfsupple.click_fenetre2(Sender: TObject);
//--------------------------------------------------
begin
 speedbutton2.down:=false;
 speedbutton2.font.color:=clblack;
 no_fenetre:=2;
end;

procedure Tfsupple.fitte_tolerance(Sender: TObject);
//---------------------------------------------------
var
  tol            : double;
  s              : string;
  i              : integer;
  w              : word;
begin
   if (listbox4.itemIndex = -1)then begin
     showmessage('Please first select a Cell found by Truecell');
     exit;
   end;
   for i:=1 to 6 do cel[i]:=crysum_truecell[listbox4.itemIndex+1].maille[i];
   quel_systeme;
   fit_tolerance(tol);
   beep;beep;
   str(tol:6:3,s);
   w:=messageDlg('The best estimated angular tolerance is '+
   s+'. Do you want to replace the old value?',
   mtConfirmation,mbYesNoCancel,0);
   if (w = mrNo) or (w = mrAbort) then exit;
   fsupple.edit4.text:=s;
   tolerance:=tol;
   beep;
end;

end.

