unit unit2;
//--------

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math;

  procedure efface_stringGrid2;
  procedure lit_strinGGrid2;
  procedure ecrit_stringgrid2;

implementation

uses unit1, unit4, unit5, unit6, mathhkl, fichiers;

procedure efface_stringGrid2;
//---------------------------
var
  i,j               : integer;
begin
    with form1.stringGrid2 do begin
        colwidths[0]:=52;
        colwidths[1]:=52;
        colwidths[2]:=43;
        colwidths[3]:=20;
        for I:=0 to ColCount-1 do  for J:=0 to RowCount-1 do Cells[I,J] := '';
        cells[0,0]:='';
        cells[1,0]:='Dhkl';
        cells[2,0]:='Area';
        cells[3,0]:='Nb.';
    end;
    if (form1.radiogroup1.ItemIndex = 0)then
    form1.stringGrid2.cells[0,0]:='Theta' else
    form1.stringGrid2.cells[0,0]:='2Theta';
    form1.edit7.text:='';
end;

procedure ecrit_stringGrid2;
//--------------------------
var
i,j          : integer;
d            : real;
s            : string;
begin
   efface_stringGrid2;

   //Rangement en theta croissant
   for i:=1 to nb_raies_dif-1 do begin
       for j:=i+1 to nb_raies_dif do begin
         if (theta_dif[i] > theta_dif[j]) then begin
           d:=theta_dif[j];
           theta_dif[j]:=theta_dif[i];
           theta_dif[i]:=d;
           d:=intensite_dif[j];
           intensite_dif[j]:=intensite_dif[i];
           intensite_dif[i]:=d;
         end;
       end;
   end;

   with form1 do begin
      stringgrid2.rowcount:=nb_raies_dif+3;
      if (stringgrid2.rowcount < 20)then stringgrid2.rowcount:=20;
      for i:=1 to nb_raies_dif do begin
         stringGrid2.cells[3,i]:=intToStr(i);
         if (form1.RadioGroup1.ItemIndex = 0) then str(0.5*theta_dif[i]:7:3,s)
         else str(theta_dif[i]:7:3,s);
         stringGrid2.cells[0,i]:=s;
         d:=lambda/(2*sin(theta_dif[i]/114.5916));
         str(d:8:4,s);
         stringGrid2.cells[1,i]:=s;
         str(intensite_dif[i]:8:0,s);
         StringGrid2.cells[2,i]:=s;
      end;
      str(lambda:8:5,s);
      edit7.text:=s;
   end;
   ecrit_stringgrid4;
end;

procedure lit_stringgrid2;
//-----------------------
var
  s                 : string;
  ier,i             : integer;
  x,d               : real;
begin
  nb_raies_dif:=0;
  with Form1.StringGrid2 do begin
    for i:=1 to rowcount-1 do begin
      s:=form1.edit7.text;
      val(s,lambda,ier);
      if (ier > 0)then begin
        erreur('Error on Lambda');
        exit;
      end;
      if (lambda = 0)then begin
        erreur('Type first the wavelength');
        exit;
      end;
      s:=Cells[0,i];
      s:=trim(s);
      if (s = '')then continue;
      val(s,x,ier);
      if (ier > 0)then begin
         erreur('Error at '+' row,'+intToStr(i));
         exit;
      end;
      nb_raies_dif:=nb_raies_dif+1;
      if (form1.RadioGroup1.ItemIndex = 0)then begin
        d:=0.5*lambda/sin(x/56.2957);
        theta_dif[nb_raies_dif]:=2*x;
        theta_dif_old[i]:=2*x;
      end else begin
        d:=0.5*lambda/sin(x/112.5914);
        theta_dif[nb_raies_dif]:=x;
        theta_dif_old[nb_raies_dif]:=x;
      end;
      str(d:7:3,s);
      Cells[1,i]:=s;
      s:=cells[2,i];
      s:=trim(s);
      if (s = '')then s:='100';
      val(s,x,ier);
      if (ier > 0)then begin
         erreur('Error at '+' row,'+intToStr(i));
         exit;
      end;
      intensite_dif[nb_raies_dif]:=x;
      cells[3,i]:=inttostr(i);
    end;
  end;
  theta_max:=0;
  theta_min:=190;
  for i:= 1 to nb_raies_dif do begin
    if (theta_dif[i] > theta_max) then theta_max:=theta_dif[i];
    if (theta_dif[i] < theta_min) then theta_min:=theta_dif[i];
  end;
  theta_min:=theta_min-2;
  theta_max:=theta_max+2;
  theta_min_depart:=theta_min;
  theta_max_depart:=theta_max;
  ecrit_stringGrid2;
  ecrit_paneau19;
  if (theta_max <> 0)then dessin;
end;


end.
