unit unit4;


interface

uses
   SysUtils, math;

procedure ecrit_stringgrid4;
procedure efface_stringGrid5;
procedure efface_stringGrid4;
procedure ecrit_stringgrid5;

implementation

uses
  mathhkl, unit1, unit6;

procedure efface_stringGrid5;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid5 do begin
      for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
  end;
end;

procedure efface_stringGrid4;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid4 do begin
      for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
  end;
end;

procedure ecrit_stringgrid4;
//-------------------------
var
  i,j        : integer;
  s          : string;
  d          : real;
begin
  with form1.stringGrid4 do begin
    if (nb_raies_dif < 25)then begin
      rowcount:=25;
    end else begin
      rowcount:=nb_raies_dif+1;
    end;
    for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
    cells[0,0]:='Nb';
    cells[1,0]:='Dhkl';
    colwidths[0]:=24;
    for i:= 1 to 2 do colwidths[i]:=42+7;
    if (form6.radiogroup1.ItemIndex = 1) then cells[2,0]:='2Theta'
    else cells[2,0]:='Theta';
    for i:=1 to nb_raies_dif do begin
      cells[0,i]:=intToStr(i);
      if (form6.radiogroup1.ItemIndex = 1) then str(theta_dif[i]:8:3,s)
      else str(0.5*theta_dif[i]:8:3,s);
      cells[2,i]:=s;
      d:=lambda/(2*sin(theta_dif[i]/114.5916));
      str(d:8:4,s);
      cells[1,i]:=s;
    end;
  end;
end;

procedure ecrit_stringgrid5;
//--------------------------
var
  i,j              : integer;
  s,s1,s2          : string;
begin
  with form1.stringgrid5 do begin
    if (nb_raies_indx < 25)then begin
      rowcount:=25;
    end else begin
      rowcount:=nb_raies_indx+1;
    end;
    for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
    cells[0,0]:='h   k   l';
    cells[1,0]:='Dhkl';
    if (form6.radiogroup1.ItemIndex = 1) then cells[2,0]:='2Theta'
    else cells[2,0]:='Theta';
    for i:=1 to nb_raies_indx do begin
      {hkl}
      with raies_indx[i] do begin
        str(hr:3,s);
        str(kr:3,s1);
        str(lr:3,s2);
        s:=s+s1+s2;
        {dhkl}
        cells[0,i]:=s;
        str(dr:7:4,s);
        cells[1,i]:=s;
        {thta ou 2thta}
        if (form6.radiogroup1.ItemIndex = 1) then str(dtheta:7:3,s)
        else str(0.5*dtheta:7:3,s);
        cells[1+1,i]:=s;
      end;
    end;
  end;
end;

end.
