unit unit5;

interface
uses
   SysUtils, forms, math;

procedure efface_stringGrid6;
procedure efface_stringGrid8;
procedure ecrit_stringGrid8;
procedure ecrit_stringGrid6;
procedure affine;
procedure echange;
procedure restaure;
procedure ecrit_param_depart;
procedure efface_par_affines;
procedure ecrit_fichier_excel;

implementation

uses
  unit1, mathhkl,unit2,unit3, unit4, unit6,unit8, mcrnl;

type
  tab_int12                 = array[1..12] of smallint;
  tab_real8                 = array[1..8] of single;
  tab_real500               = array[1..500] of single;

var
   ah,ak,al,theta_affi                      : tab_real500;
   par,sig,cle,sup                          : tab_real8;
   residu                                   : single;
   nb_par                                   : integer;
   vol_av,vol_ap,sig_vol                    : double;
procedure efface_stringGrid6;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid6 do begin
      for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
  end;
  form1.edit40.text:='';
end;

procedure efface_stringGrid8;
//---------------------------
var
  i,j  : integer;
begin
  with form1.stringGrid8 do begin
      for I := 0 to ColCount - 1 do
      for J:= 0 to RowCount - 1 do Cells[I,J] := '';
  end;
  form1.edit41.text:='';
end;

//Ecarts quadratiques moyens avant affinement
procedure calc_ecart_avant;
//-------------------------
var
  i           : integer;
  som         : real;
  s           : string;
begin
  if (nb_raies_obs = 0)then exit;

  if (nb_raies_obs-nb_par <= 0)then begin
    form1.edit40.text:='';
    exit;
  end;

  som:=0;
  if (form6.radiogroup1.ItemIndex = 1)then
    for i:=1 to nb_raies_obs do som:=som+sqr(dtheta_obs[i]-dtheta_calc[i])
  else
    for i:=1 to nb_raies_obs do som:=som+sqr(0.5*(dtheta_obs[i]-dtheta_calc[i]));
  som:=sqrt(som)/(nb_raies_obs-nb_par);
  str(som:8:5,s);
  form1.edit40.text:=s;
end;

//Ecarts quadratiques moyens aprs affinement
procedure calc_ecart_apres;
//-------------------------
var
  i           : integer;
  som         : real;
  s           : string;
begin
  if (flag_affinement = false) then exit;
  if (nb_raies_obs = 0)then exit;

  if (nb_raies_obs-nb_par <= 0)then begin
    form1.edit41.text:='';
    exit;
  end;

  som:=0;
  if (form1.radiogroup1.ItemIndex = 1)then begin             //2theta
    for i:=1 to nb_raies_obs do
      som:=som+sqr((dtheta_obs_cor[i])-2*theta_affi[i]);    //Celref.dll retourne theta
  end else begin                                            // theta
    for i:=1 to nb_raies_obs do
      som:=som+sqr(0.5*(dtheta_obs_cor[i]-theta_affi[i]));  //Celref.dll retourne theta
  end;
  som:=sqrt(som)/(nb_raies_obs-nb_par);
  str(som:8:5,s);
  form1.edit41.text:=s;
end;

procedure ecrit_par_affines;
//--------------------------
var
   s           : string;
begin
  with form1 do begin
    if (radiogroup1.itemIndex = 1)then str(zero_shift:8:6,s) else
    str(zero_shift*0.5:8:6,s);
    edit32.text:=s;
    str(par[2]:8:5,s);
    edit35.text:=s;
    str(par[3]:9:4,s);
    edit14.text:=s;
    str(par[4]:9:4,s);
    edit15.text:=s;
    str(par[5]:9:4,s);
    edit16.text:=s;
    str(par[6]:8:3,s);
    edit17.text:=s;
    str(par[7]:8:3,s);
    edit18.text:=s;
    str(par[8]:8:3,s);
    edit19.text:=s;

    //Affichage des sigmas
    str(sig[1]:8:6,s);
    edit33.text:=s;
    str(sig[2]:8:4,s);
    edit36.text:=s;
    str(sig[3]:8:4,s);
    edit20.text:=s;
    str(sig[4]:8:4,s);
    edit21.text:=s;
    str(sig[5]:8:4,s);
    edit22.text:=s;
    str(sig[6]:8:3,s);
    edit23.text:=s;
    str(sig[7]:8:3,s);
    edit24.text:=s;
    str(sig[8]:8:3,s);
    edit25.text:=s;

//Affichage volume et sigma
    str(vol_av:12:2,s);
    edit44.text:=s;
    str(vol_ap:12:2,s);
    edit45.text:=s;
    str(sig_vol:12:4,s);
    edit46.text:=s;

    calc_ecart_avant;
    calc_ecart_apres;
 end;
end;

procedure efface_par_affines;
//--------------------------
begin
 with form1 do begin
   edit14.text:='';edit15.text:='';edit16.text:='';edit17.text:='';
   edit18.text:='';edit19.text:='';edit20.text:='';edit21.text:='';
   edit22.text:='';edit23.text:='';edit24.text:='';edit25.text:='';
   edit32.text:='';edit33.text:='';edit35.text:='';edit36.text:='';
   edit41.text:='';
   edit29.text:='0';
 end;
end;

procedure ecrit_param_depart;
//---------------------------
var
  s   : string;
begin
  with form1 do begin
    str(cel[1]:9:4,s);
    edit8.text:=s;
    str(cel[2]:9:4,s);
    edit9.text:=s;
    str(cel[3]:9:4,s);
    edit10.text:=s;
    str(cel[4]:8:3,s);
    edit11.text:=s;
    str(cel[5]:8:3,s);
    edit12.text:=s;
    str(cel[6]:8:3,s);
    edit13.text:=s;
    str(zero_shift:8:6,s);
    edit29.text:=s;
    str(lambda:8:5,s);
    edit34.text:=s;
  end;
end;

//Ecriture des rsultats dans StrinGrid6
procedure ecrit_stringGrid6;
//-----------------------------
var
  i,j   : integer;
  s,s1  : string;
begin
  with form1.stringGrid6 do begin
    colwidths[0]:=15;
    colwidths[2]:=42+22;
    if (nb_raies_obs < 25)then begin
      rowcount:=25;
    end else begin
      rowcount:=nb_raies_obs+1;
    end;
    for I := 0 to ColCount-1  do
      for J:= 0 to RowCount-1 do Cells[I,J] := '';
    cells[0,0]:='No.';
    cells[1,0]:='h k l';
    if (form6.radiogroup1.ItemIndex = 1) then begin
      cells[2,0]:='2TObs-shift';
      cells[3,0]:='2TCalc';
    end else begin
      cells[2,0]:='TObs-shift';
      cells[3,0]:='TCalc';
    end;
    cells[4,0]:='Dif.';
    for i:=1 to nb_raies_obs do begin
      cells[0,i]:=intToStr(i);
      s:='';
      str(h_obs[i]:2,s1);
      s:=s+s1;
      str(k_obs[i]:2,s1);
      s:=s+s1;
      str(l_obs[i]:2,s1);
      s:=s+s1;
      cells[1,i]:=s;

      if (form6.radiogroup1.ItemIndex = 1) then str(dtheta_obs_cor[i]:8:3,s)
      else str(0.5*dtheta_obs_cor[i]:8:3,s);
      cells[2,i]:=s;                            //Celref.dll retourne theta
      if (form6.radiogroup1.ItemIndex = 1) then str(2*theta_affi[i]:8:3,s)
      else str(theta_affi[i]:8:3,s);
      cells[3,i]:=s;
      if (form6.radiogroup1.ItemIndex = 1) and (dtheta_obs_cor[i] > 0) then  //Celref.dll retourne theta
      str((dtheta_obs_cor[i]-2*theta_affi[i]):8:4,s)else
      str((0.5*dtheta_obs_cor[i] - theta_affi[i]):8:4,s);
      cells[4,i]:=s;
      if (form6.radiogroup1.ItemIndex = 1) and (dtheta_obs_cor[i] = 0) then  //Celref.dll retourne theta
      str((dtheta_obs[i]-2*theta_affi[i]):8:4,s)else
      str(0.5*dtheta_obs[i] - theta_affi[i]:8:4,s);
      cells[5,i]:=s;
    end;
    calc_ecart_apres;

  end;
end;

procedure relit_parametres(var ier:integer);
//-----------------------------------------
var
  i             : integer;
  s             : string;
  x             : real;
begin
  ier:=0;
  for i:=1 to 8 do cle[i]:=0;
  for i:=1 to 6 do par[i+2]:=cel[i];
  s:=form1.edit34.text;
  val(s,x,ier);
  if (ier > 0)then begin
    erreur('Error on Lambda!');
    ier:=1;
    exit;
  end;
  lambda:=x;
  par[2]:=x;
  s:=form1.edit29.text;
  val(s,x,ier);
  if (ier > 0)then begin
    erreur('Error on Angular Shift!');
    ier:=1;
    exit;
  end;
  par[1]:=x;
  with form1 do begin
    if checkBox7.checked then cle[1]:=1;
    if checkBox8.checked then cle[2]:=1;
    if checkBox1.checked then cle[3]:=1;
    if checkBox2.checked then cle[4]:=1;
    if checkBox3.checked then cle[5]:=1;
    if checkBox4.checked then cle[6]:=1;
    if checkBox5.checked then cle[7]:=1;
    if checkBox6.checked then cle[8]:=1;
  end;
  nb_par:=0;
  for i:=1 to 8 do begin
    if (cle[i] = 0)then continue;
    nb_par:=nb_par+1;
  end;
  if (nb_raies_obs < nb_par+1)then begin
      erreur('Nb of selected reflections too low');
      ier:=1;
      exit;
  end;
end;

//Lancement de l 'affinement
procedure affine;
//--------------
var
  isys                           : smallInt;
  i,ier,j,i1,i2,i3               : integer;
  s,s1                           : string;
  baite                          : byte;
  nomf                           : textfile;
  a_moy,dd,delta,x,y             : double;
  c                              : char;
begin
  if(nb_raies_obs = 0)then begin
    erreur('No selected reflections!');
    exit;
  end;

  isys:=ord(systeme[1]);
  relit_parametres(ier);

  if (ier = 1)then exit;

  for i:=1 to 500 do begin
    ah[i]:=0;
    ak[i]:=0;
    al[i]:=0;
    theta_affi[i]:=0;
  end;
  for i:=1 to nb_raies_obs do begin
    ah[i]:=h_obs[i];
    ak[i]:=k_obs[i];
    al[i]:=l_obs[i];
    theta_affi[i]:=dtheta_obs[i];
    dtheta_obs_cor[i]:=0;
  end;

//Ecriture dans le fichier celref.inp pour test par TSTCEL
  assignFile(nomf,'celref.inp');
  rewrite(nomf);
  s:=ExtractFileName(nom_fichier_dif);
  writeln(nomf,s);
  writeln(nomf,systeme);
  for i:=3 to 8 do writeln(nomf,par[i]:8:4,cle[i]:8:4);
  if (mode_shift = 1)then  writeln(nomf,par[1]:8:4,cle[1]:8:4)
  else writeln(nomf,par[1]:8:4,2*cle[1]:8:4);
  writeln(nomf,par[2]:8:4,cle[2]:8:4);
  for i:=1 to nb_raies_obs do
  writeln(nomf,ah[i]:4:0,ak[i]:4:0,al[i]:4:0,dtheta_obs[i]:10:4);
  closefile(nomf);
  ecrit_stringgrid8;

//==============================================================================
  rafine(vol_av,vol_ap,sig_vol,ier);
  if (ier = 1)then exit;
//==============================================================================

   assignfile(nomf,'celref.out');
   reset(nomf);
   while not (eof(nomf)) do begin
     readln(nomf,s);
     if (pos('Final values',s) > 0)then break;
   end;
   for i:=1 to 2 do readln(nomf);
   for i:=1 to 8 do read(nomf,par[i]);
   readln(nomf);
   for i:=1 to 8 do read(nomf,sig[i]);
   readln(nomf);
   for i:=1 to 4 do readln(nomf);

   for i:=1 to nb_raies_obs do begin
      readln(nomf,i1,i2,i3,x,y,theta_affi[i]);
      theta_affi[i]:=0.5*theta_affi[i];
   end;
   closefile(nomf);

   flag_affinement:=true;
   for i:=1 to 6 do cel_af[i]:=par[i+2];
   flag_affinement:=true;

//Calcul des observs corrigs du dplacement
  zero_shift:=par[1];
  for i:=1 to nb_raies_obs do begin
    if (mode_shift = 1)then  delta:=zero_shift               // Mode shift constant
    else delta:=zero_shift*cos(dtheta_obs[i]/pir2);      //Mode excentricit
    dtheta_obs_cor[i]:=dtheta_obs[i]-delta;
  end;

//Affichage des rsultats
  ecrit_stringGrid6;

//Affichage des paramtres affins}
  ecrit_par_affines;
end;

procedure ecrit_stringGrid8;
//--------------------------
var
  i,j          : integer;
  s,s1,s2,s3   : string;
  //som          : real;
begin
  with form1.stringGrid8 do begin
    for I := 0 to ColCount-1  do
      for J:= 0 to RowCount-1  do
        Cells[I,J] := '';
  end;
  with form1.stringGrid8 do begin
    colwidths[0]:=20;
    colwidths[3]:=60;
    cells[0,0]:='Nb.';
    cells[1,0]:='h   k   l';
    if (form6.radiogroup1.ItemIndex = 1) then begin
      cells[2,0]:='2T Obs';
      cells[3,0]:='2TObs-shift';
      cells[4,0]:='2T Calc';
    end else begin
      cells[2,0]:='T Obs';
      cells[3,0]:='TObs-shift';
      cells[4,0]:='T Calc';
    end;
    cells[5,0]:='Diff.';
    for i:=1 to nb_raies_obs do begin
      str(i:2,s);
      cells[0,i]:=s;
      str(h_obs[i]:3,s1);
      str(k_obs[i]:3,s2);
      str(l_obs[i]:3,s3);
      cells[1,i]:=s1+s2+s3;
      if (dtheta_obs_cor[i] = 0) then dtheta_obs_cor[i]:=dtheta_obs[i];
      if (form6.radiogroup1.ItemIndex = 1) then begin
        str(dtheta_obs[i]:8:3,s);
        cells[2,i]:=s;
        str(dtheta_obs_cor[i]:8:3,s);
        cells[3,i]:=s;
        str(dtheta_calc[i]:8:3,s);
        cells[4,i]:=s;
        (*if (dtheta_obs_cor[i] = 0)then str((dtheta_obs[i]-dtheta_calc[i]):8:4,s)
        else*) str((dtheta_obs_cor[i]-dtheta_calc[i]):8:4,s);
        cells[5,i]:=s;
      end else begin
        str(0.5*dtheta_obs[i]:8:3,s);
        cells[2,i]:=s;
        str(0.5*dtheta_obs_cor[i]:8:3,s);
        cells[3,i]:=s;
        str(0.5*dtheta_calc[i]:8:3,s);
        cells[4,i]:=s;
        (*if (dtheta_obs_cor[i] = 0)then str(0.5*(dtheta_obs[i]-dtheta_calc[i]):8:4,s)
        else*) str(0.5*(dtheta_obs_cor[i]-dtheta_calc[i]):8:4,s);
        cells[5,i]:=s;
      end;
    end;
  end;

  if (nb_raies_obs = 0)then exit;
  calc_ecart_avant;
end;

//Echange les paramtres de dpart par les paramtres affins
procedure echange;
//---------------
var
  i,j,k,i_at               : integer;
  dist,dist_min,delta      : real;
begin
  if (nb_raies_obs = 0)then exit;
  zero_shift:=par[1];
  lambda:=par[2];
  for i:=1 to 6 do cel[i]:=cel_af[i];
  for i:= 0 to form1.stringGrid6.colcount-1 do
  for j:=0 to form1.stringGrid6.rowcount-1 do form1.stringGrid6.cells[i,j]:='';
  form1.edit14.text:='';
  ecrit_maille;
  ecrit_param_depart;
  calcul_indx;
  for i:=1 to nb_raies_dif do begin
      if (mode_shift = 1)then
         delta:=zero_shift                                   // Mode shift constant
      else
        delta:=zero_shift*cos(theta_dif[i]/114.2957);      //Mode excentricit
      theta_dif[i]:=theta_dif[i]-delta;
  end;
  nb_raies_obs:=0;
  efface_stringgrid3;  //Selected reflections (volet 3)
  efface_stringgrid6;  //After refinement (volet 4)
  efface_stringgrid8;  //before refinement (volet 4)
  ecrit_stringgrid1;   //Calculated diagram (2)
  ecrit_stringgrid2;   //Measured reflections (1)
  ecrit_stringGrid4;   // measured reflections  (volet 3)
  ecrit_stringGrid5;   //Calculated reflections (volet 3)
  efface_par_affines;
  dessin;
  form1.PageControl1.activepage:=form1.TabSheet4;
end;

//Restauration de la maille de dpart
procedure restaure;
//----------------
var
  i,j,k,i_at     : integer;
  dist,dist_min  : real;
begin
  //if (form1.edit14.text = '')then exit;
  for i:=1 to 6 do cel[i]:=cel_depart[i];
  for i:= 0 to form1.stringGrid6.colcount-1 do
  for j:=0 to form1.stringGrid6.rowcount-1 do form1.stringGrid6.cells[i,j]:='';
  form1.edit14.text:='';
  ecrit_maille;
  zero_shift:=0;
  ecrit_param_depart;
  calcul_indx;
  nb_raies_obs:=0;
  for i:=1 to nb_raies_dif do theta_dif[i]:=theta_dif_old[i];
  zero_shift:=0;
  efface_stringgrid3;  //Selected reflections (volet 3)
  efface_stringgrid6;  //After refinement (volet 4)
  efface_stringgrid8;  //before refinement (volet 4)
  ecrit_stringgrid1;   //Calculated diagram (2)
  ecrit_stringgrid2;   //Measured reflections (1)
  ecrit_stringGrid4;   // measured reflections  (volet 3)
  ecrit_stringGrid5;   //Calculated reflections (volet 3)
  efface_par_affines;
  dessin;
  form1.PageControl1.activepage:=form1.TabSheet4;
end;

procedure ecrit_fichier_excel;
//-----------------------------
var
  nomf,lit  : textfile;
  s         : char;
  chaine    : string;
  i,j,ier   : integer;
  x,y,sigma : array[1..8] of real;
  dobs,dcalc: real;
  vol1,vol2,svol  : real;
begin
    val(form1.edit44.text,vol1,ier);
    val(form1.edit45.text,vol2,ier);
    val(form1.edit46.text,svol,ier);
    assignfile(lit,'celref.out');
    reset(lit);
    assignfile(nomf,'Excel.txt');
    rewrite(nomf);
    s:=chr(9);
    //titre
    readln(lit);
    readln(lit,chaine);
    writeln(nomf,chaine,s);
    readln(lit);
    readln(lit,chaine);   //n of ref
    writeln(nomf,chaine,s);
    readln(lit,chaine);   //ref. constr
    writeln(nomf,chaine,s);
    for i:=1 to 3 do readln(lit);
    for i:=1  to 8 do read(lit,x[i]); //b(i) avant
    readln(lit);
    for i:=1 to 5 do readln(lit);
    for i:=1  to 8 do read(lit,y[i]);// b(i) apres
    readln(lit);
    for i:=1 to 8 do read(lit,sigma[i]);
    readln(lit);
    for i:=1 to 2 do readln(lit);
    readln(lit,chaine);   //n of cycles
    writeln(nomf,chaine);
    for i:=1 to nb_raies_obs+4 do readln(lit);
    writeln(nomf);
    readln(lit,chaine);   //residu 1
    writeln(nomf,chaine,s);
    readln(lit);
    readln(lit,chaine);   //residu 2
    writeln(nomf,chaine,s);
    writeln(nomf);
    if (mode_shift = 1)then writeln(nomf,s,'2delta(T)',s,'Lambda',s,
    'a',s,'b',s,'c',s,'alpha',s,'beta',s,'gamma',s,'Vol',s)
    else  writeln(nomf,s,'e/R()',s,'Lambda',s,'a',s,
    'b',s,'c',s,'alpha',s,'beta',s,'gamma',s,'Vol',s);
    write(nomf,'Initial',s);
    write(nomf,x[1]:8:5,s,x[2]:8:5,s);
    for i:=3 to 5 do write(nomf,x[i]:8:4,s);
    for i:=6 to 8 do write(nomf,x[i]:8:3,s);
    writeln(nomf,vol1:15:2);
    //writeln(nomf);
    write(nomf,'Final',s);
    write(nomf,y[1]:8:5,s,y[2]:8:5,s);
    for i:=3 to 5 do write(nomf,y[i]:8:4,s);
    for i:=6 to 8 do write(nomf,y[i]:8:3,s);
    writeln(nomf,vol2:15:2);
//    writeln(nomf);
    write(nomf,'Sigmas',s);
    write(nomf,sigma[1]:8:5,s,x[2]:8:5,s);
    for i:=3 to 5 do write(nomf,sigma[i]:8:4,s);
    for i:=6 to 8 do write(nomf,sigma[i]:8:3,s);
    writeln(nomf,svol:15:4);
//    writeln(nomf);

   // writeln(nomf,s,zero_shift:8:5,s,par[2]:8:5,s,par[3]:8:4,s,par[4]:8:4,s,
   // par[5]:8:4,s,par[6]:8:3,s,par[7]:8:3,s,par[8]:8:3,s);
    writeln(nomf);
    writeln(nomf,'    H',s,'    K',s,'    L',s,'  2T(Obs)',s,'  2T-Zero',s,
    '  2Th(Cal)',s,'   Dif',s,'  DoCor.',s,'  DCalc',s);
    writeln(nomf);
    if (fexcel.radiogroup1.itemIndex = 0)then begin
      for i:=1 to nb_raies_obs do begin
        dobs:=lambda/(2*sin(dtheta_obs_cor[i]/114.5916));
        dcalc:=lambda/(2*sin(theta_affi[i]/57.2957));
        writeln(nomf,h_obs[i]:4,s,k_obs[i]:4,s,l_obs[i]:4,s,dtheta_obs[i]:9:3,s,
        dtheta_obs_cor[i]:9:3,s,2*theta_affi[i]:9:3,s,
        dtheta_obs_cor[i]-2*theta_affi[i]:9:3,s,dobs:9:4,s,dcalc:9:4,s);
      end;
    end else begin
      for i:=1 to nb_raies_dif do begin
        ier:=1;
        for j:= 1 to nb_raies_obs do begin
          if (abs(theta_dif[i]-dtheta_obs[j]) < 0.0001)then begin
            dobs:=lambda/(2*sin(dtheta_obs_cor[j]/114.5916));
            dcalc:=lambda/(2*sin(theta_affi[j]/57.2957));
            writeln(nomf,h_obs[j]:4,s,k_obs[j]:4,s,l_obs[j]:4,s,dtheta_obs[j]:8:3,s,
            dtheta_obs_cor[j]:8:3,s,2*theta_affi[j]:8:3,s,
            dtheta_obs_cor[j]-2*theta_affi[j]:8:3,s,dobs:9:4,s,dcalc:9:4,s);
            ier:=0;
            break;
          end;
        end;
        if (ier = 1)then writeln(nomf,s,s,s,theta_dif[i]:8:3,s);
      end;
    end;
    closefile(nomf);
    closefile(lit);
end;
end.
