unit lepage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, checklst, ColorBtns, math;

type
  Tflepage = class(TForm)
    Memo3: TMemo;
    Label3: TLabel;
    Label5: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel5: TPanel;
    ListBox1: TListBox;
    Edit3: TEdit;
    BitBtn3: TBitBtn;
    ListBox6: TListBox;
    Panel1: TPanel;
    Label4: TLabel;
    Label14: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    CheckListBox1: TCheckListBox;
    Edit2: TEdit;
    Edit11: TEdit;
    BitBtn1: TBitBtn;
    BitBtn4: TBitBtn;
    Color95Button1: TColor95Button;
    Label11: TLabel;
    Edit9: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    Panel4: TPanel;
    Label6: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    RadioGroup2: TRadioGroup;
    BitBtn2: TBitBtn;
    BitBtn5: TBitBtn;
    ListBox2: TListBox;
    BitBtn13: TBitBtn;
    procedure go(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure edit_print(Sender: TObject);
    procedure on_click_checklist(Sender: TObject);
    procedure on_change(Sender: TObject);
    procedure on_click_listbox1(Sender: TObject);
    procedure Color95Button1Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure calcul_densite(Sender: TObject);
    //procedure BitBtn2Click(Sender: TObject);
    //procedure selecte_ligne(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  flepage: Tflepage;

implementation

{$R *.DFM}

uses
  mathhkl, instru, unit1, supple, supercell, Unit70;

var
  psys                     : string[4];
  no_psys                  : integer;
  v0                       : real;
  nb_lignes,no_ligne       : integer;

{---DLL lepage2-----------------------------------------------------------}
procedure lepage2;
                 far;stdcall;external 'lepage2.dll' index 1;

procedure search_syst(var tab:tab_reel);
//--------------------------------------
var
  dif1,dif2,dif3,alpha,beta,gamma          : real;
  i                                        : integer;
begin
 psys:='';
 no_psys:=7;
 dif1:=abs(tab[1]-tab[2]);
 dif2:=abs(tab[2]-tab[3]);
 dif3:=abs(tab[3]-tab[1]);
 alpha:=tab[4];beta:=tab[5];gamma:=tab[6];
//Cubique, quadratique, orthorhombique
 if (abs(alpha-90) < epsa) and (abs(beta-90) < epsa) and (abs(gamma-90) < epsa)then begin
   if (dif1 < epsb) and (dif2 < epsb) and (dif3 < epsb) then begin
     psys:='CUBI';
     no_psys:=1;
     for i:= 4 to 6 do tab[i]:=90;
     exit;
   end;
   if (dif1 < epsb) and (dif2 > epsb) then begin
     psys:='TETR';
     no_psys:=2;
     for i:= 4 to 6 do tab[i]:=90;
     exit;
   end;
   if (dif1 > epsb) and (dif2 > epsb) then begin
     psys:='ORTH';
     no_psys:=3;
     for i:= 4 to 6 do tab[i]:=90;
     exit;
   end;
 end;

//Hexagonal
 if (dif1 < epsb) and (abs(alpha-90)< epsa) and (abs(beta-90) < epsa)
                  and (abs(gamma-120)< epsa) then begin
   psys:='HEXA';
   no_psys:=4;
   for i:= 4 to 5 do tab[i]:=90;
   tab[6]:=120;
   exit;
 end;

//Rhomboedrique
 if (dif1 < epsb)       and (dif2 < epsb)         and (dif3 < epsb)   (*and
 (abs(alpha-90) < epsa) and (abs(beta-90) < epsa) and (abs(gamma-90) < epsa)*) then begin
   psys:='RHOM';
   no_psys:=5;
   for i:= 4 to 6 do tab[i]:=tab[4];
   exit;
 end;

//Monoclinique
 if (abs(alpha-90) < epsa) and (abs(gamma-90)< epsa) and (abs(beta-90)> epsa)then begin
   psys:='MONO';
   no_psys:=6;
   tab[4]:=90;
   tab[6]:=90;
   exit;
 end;
end;

procedure posxy(memo:TMemo;var x,y:integer);
begin
  y:=SendMessage(memo.Handle,EM_LineFromChar,memo.SelStart,0);
//SendMessage envoie le message EM_LineFromChar  windows en donnant  comme
//paramtre le handle de Memo (Memo.Handle) et memo.SelStart c'est  dire
//le nombre de caractres avant le curseur EM_LineFromChar est un message
//qui renvoie le num de la ligne qui contient le n ime caractre.
//(n ime est ici Memo.SelStart)
  x:=memo.Selstart-SendMessage(memo.Handle,EM_LineIndex,y,0)+1;
// EM_LineIndex est un message permettant de retrouver le nombre de caractre
//qu'il y a du dbut du mmo au dbut de la ligne n y

end;

function volume(var maille:tab_reel): real;
//----------------------------------------
var
  q,ca,cb,cc        : real;
begin
      ca:=cos(maille[4]/57.2957);
      cb:=cos(maille[5]/57.2957);
      cc:=cos(maille[6]/57.2957);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      volume:=maille[1]*maille[2]*maille[3]*sqrt(q);
end;

procedure Tflepage.go(Sender: TObject);
//-----------------------------------
var
  nomf                                     : textfile;
  s,ss,s1,s2,sm,systeme_l                  : string;
  s21                                      : string[22];
  i,j,k,no,ier                             : integer;
  no_syst,no_psys_lim                      : integer;
  carl                                     : string;
  c1,c2,c3                                 : string[4];
  maille,maille2                           : tab_reel;
  v,vv1,vv_max,element_max,u_max,par_max   : real;
  solutions                                : array[1..100,1..6] of real;
  numero_sol_crysfire,i20_sol,i20_suppl    : integer;
  v_sol,vv_sol,v_suppl,vv_suppl,fom_suppl,
                                 fom_sol   : real;
  x,ar,alpha                               : real;
begin

//------------------------------------------------------------------------------

//Acquisition tolrance sur l'angle
    s:=edit1.Text;
    val(s,epsa,ier);
    if (ier > 0)then begin
      erreur('Error on Parameter tolerance');
      edit1.setfocus;
      exit;
    end;

//Acquisition valeurs des tolrances pour comparaison
    s:=edit4.Text;
    val(s,epsb2,ier);
    if (ier > 0)then begin
      erreur('Error on Parameter tolerance');
      edit1.setfocus;
      exit;
    end;

    s:=edit5.Text;
    val(s,epsa2,ier);
    if (ier > 0)then begin
      erreur('Error on angular tolerance');
      edit1.setfocus;
      exit;
    end;

//Acquisition tolrance sur le paramtre
    s:=edit2.Text;
    val(s,epsb,ier);
    if (ier > 0)then begin
      erreur('Error on angular tolerance');
      edit1.setfocus;
      exit;
    end;

//Acquisition tolrance sur Max vector
   s:=edit9.text;
   val(s,u_max,ier);
   if (ier > 0)then begin
     erreur('Read error');
     edit9.setfocus;
   end;

//Acquisition tolrance sur V/V0
   s:=edit11.text;
   val(s,vv_max,ier);
   if (ier > 0)then begin
     erreur('Read error');
     edit11.setfocus;
   end;

   nb_lignes:=0;
   listbox2.clear;
   memo3.clear;

//Solution slectionne
   if (listbox1.itemIndex <= 0)then begin
      beep;
      exit;
   end;
   s:=listbox1.Items[listbox1.itemindex];
   delete(s,1,20);
   dec(s,maille,no,ier);
   for i:=1 to 6 do cel[i]:=maille[i];
   v0:=maille[7];
   setmat;

//Filtre des symtries possibles
    quel_systeme;
    no_syst:=7;
    if (systeme = 'CUBI')then no_syst:=1;
    if (systeme = 'TETR')then no_syst:=2;
    if (systeme = 'ORTH')then no_syst:=3;
    if (systeme = 'HEXA')then no_syst:=4;
    if (systeme = 'RHOM')then no_syst:=5;
    if (systeme = 'MONO')then no_syst:=6;
    case no_syst of
      1: Systeme_l:='Cubic';
      2: Systeme_l:='Tetragonal';
      3: Systeme_l:='Orthorhombic';
      4: Systeme_l:='Hexagonal';
      5: Systeme_l:='Rhomboedral';
    end;

//Systeme
    no_psys_lim:=no_syst;

//Selection absurde (p ex. si la sol de dpart est cubique, on ne peut demander
// une solution quadratique)

  if (checklistbox1.state[0] = cbunchecked)then begin
    j:=0;
    for i:= no_syst to 6 do begin
      if (checklistbox1.state[i] = cbchecked)then begin
        if (no_syst = 3) and (i = 4) then continue;
        if (no_syst = 3) and (i = 5) then continue;
        if (no_syst = 4) and (i = 5) then continue;
        //j:=j+1;
        j:=i;
      end;
    end;
    if (j > 0)then begin
      beep;
      showmessage
      ('No sense. '+systeme_l+' cell cannot search for a '+ checklistbox1.items[j]+' cell');
      screen.cursor:=crdefault;
      exit;
    end;
  end;

  if (color95button1.visible = false)then begin

   screen.cursor:=crHourGlass;

//Ecriture du fichier d'entre lepage.inp
   if fileexists('lepage.lis') then deletefile('lepage.lis');
   if fileexists('lepage.inp') then deletefile('lepage.inp');
   assignfile(nomf,'lepage.inp');
   rewrite(nomf);
   write(nomf,'CELL ');
   for i:=1 to 6 do write(nomf,cel[i]:10:4);
   s:=' P';
   if (systeme ='HEXA')then s:=' R';
   writeln(nomf,s);
   if (radiogroup2.itemindex = 0)then writeln(nomf,'SUPER 4')
   else writeln(nomf,'SUB 4');
   writeln(nomf,'CALC');
   writeln(nomf,'QUIT');
   closefile(nomf);

   lepage2;

  end;
//-----------------------------------------------------------------------------
  with fsupple do begin
    listbox4.clear;
    caption:='Best solution for Lepage';
    Label2.caption:='Cells found by Lepage(the first line = starting cell)';
    listbox4.clear;
    listbox2.Clear;
  end;

//Lecture du fichier lepage.lis et recherche des solutions
  assignfile(nomf,'lepage.lis');
  reset(nomf);

//Ecriture de la maille rduite;
  while not(eof(nomf)) do begin
     readln(nomf,s);
     if (pos('   INPUT CELL',s) > 0)then begin
     s:='Input '+copy(s,18,67);
     insert(' ',s,length(s)-8);
     memo3.lines.add(s);
     readln(nomf,s);
     insert(' ',s,length(s)-8);
     s:='Prim. '+copy(s,18,67);
     memo3.lines.add(s);
     readln(nomf,s);
     readln(nomf,s);
     s:='Reduc '+copy(s,18,67);
     break;
   end;
 end;
 closefile(nomf);

  i:=listbox1.itemindex;
  s:=listbox1.Items[i];
  i20_sol:=crysum[i].i20;
  vv_sol:=crysum[i].vv1;
  v_sol:=crysum[i].vol;
  fom_sol:=crysum[i].fom;
  fsupple.ListBox4.items.add(s);
  nb_sol:=1;
  for k:=1 to 6 do solutions[nb_sol,k]:=crysum[i].maille[k];

//Ecriture des supercells
 assignfile(nomf,'lepage.lis');
 reset(nomf);
 ss:='=== TRANSFORMATION MATRIX';
 while not(eof(nomf)) do begin
   readln(nomf,s);

//Dtection de la matrice de transformation
   if (pos(ss,s) > 0)then begin
     readln(nomf,s);
     sm:='';
     for i:=1 to 3 do begin
       readln(nomf,s);
       if (i = 2)then begin
         psys:=copy(s,65,4);
         //sd:=s;
       end;
       c1:=copy(s,11,5);
       c2:=copy(s,16,5);
       c3:=copy(s,21,5);
       s2:=c1+' '+c2+' '+c3;
       sm:=s2+' '+sm;
     end;
     s2:=sm;
     while (pos('(',s2) > 0)do s2[pos('(',s2)]:=' ';
     while (pos(')',s2) > 0)do s2[pos(')',s2)]:=' ';
     verif(s2);
     dec(s2,maille,no,ier);
     element_max:=0;
     for i:=1 to 9 do
     if(abs(maille[i]) > element_max)then element_max:=abs(maille[i]);
     s2:='(';
     for k:=1 to 3 do begin
       str(maille[k]:5:1,s1);
       s2:=s2+s1;
     end;
     s2:=s2+')(';
     for k:=4 to 6 do begin
       str(maille[k]:5:1,s1);
       s2:=s2+s1;
     end;

     s2:=s2+')(';
     for k:=7 to 9 do begin
       str(maille[k]:5:1,s1);
       s2:=s2+s1;
     end;
     s2:=s2+')';
     sm:=s2;
   end;

//Dtection de LAT0
   if (pos('LAT0',s)>0)then begin

//Test sur Max vector
     if(element_max > u_max)then continue;

     for i:=1 to 4 do readln(nomf,s);
     delete(s,1,22);
     dec(s,maille,no,ier);

//gamma hexagonal diffrent de 120
     if (psys = 'HEXA')then begin
        maille[6]:=120;
     end;

     maille[7]:=volume(maille); //Pb d'erreur de format pour les protines dans Lepage2
     v:=maille[7];

//maille rhombo
     if (psys = 'RHOM')then begin
       x:=sqrt(3+sqr(maille[3]/maille[1]));
       ar:=maille[1]*x/3;
       alpha:=2*57.2957*arcsin(3/(2*x));
       maille[1]:=ar;
       maille[2]:=ar;
       maille[3]:=ar;
       maille[4]:=alpha;
       maille[5]:=alpha;
       maille[6]:=alpha;
       v:=v/3;
     end;

     vv1:=maille[7]/v0;

//Test sur V/V0 max
     if (vv1 > vv_max)then continue;

//Test sur le systeme
     search_syst(maille);
     if (no_psys = 7)then continue;
     if (checklistbox1.State[no_psys] = cbchecked) or
     (checklistbox1.State[0] = cbchecked)then begin

//Solution dj trouve ?
       ier:=0;
       if (nb_sol > 1) and (radiogroup1.itemindex= 1) then begin
         for k:=1 to nb_sol do begin
           if (abs(maille[1]-solutions[k,1]) < epsb) and
           (abs(maille[2]-solutions[k,2]) < epsb) and
           (abs(maille[3]-solutions[k,3]) < epsb) and
           (abs(maille[4]-solutions[k,4]) < epsa) and
           (abs(maille[5]-solutions[k,5]) < epsa) and
           (abs(maille[6]-solutions[k,6]) < epsa) then begin
             ier:=1;
             break;
           end;
         end;
       end;
       if (ier = 1)then continue;

//Est ce une solution crysfire?
       numero_sol_crysfire:=0;
       for k:=1 to nb_sol_crysfire do begin
         s:=listbox1.items[k];
         delete(s,1,22);
         dec(s,maille2,no,ier);
         ier:=0;
         if (abs(maille[1]-maille2[1]) < epsb2) and
         (abs(maille[2]-maille2[2]) < epsb2) and
         (abs(maille[3]-maille2[3]) < epsb2) and
         (abs(maille[4]-maille2[4]) < epsa2) and
         (abs(maille[5]-maille2[5]) < epsa2) and
         (abs(maille[6]-maille2[6]) < epsa2) then begin
           numero_sol_crysfire:=k;
           break;
         end;
       end;

       s1:='';
       s:='';
       for k:=1 to 3 do begin
         if (maille[k] < 100)then str(maille[k]:7:3,s1)else
         str(maille[k]:7:2,s1);
         s:=s+s1;
       end;
       for k:=4 to 6 do begin
         str(maille[k]:7:2,s1);
         s:=s+s1;
       end;
       if (v < 10000)then str(v:9:1,s1);
       if (v > 10000)then str(v:9:0,s1);
       //if (v >=  1000000)then str(v:9:0,s1);
       s:=s+s1;

//chaine pour fsupple.listbox4
       if (numero_sol_crysfire = 0)then begin
         i20_suppl:=i20_sol;
         vv_suppl:=vv_sol;
         fom_suppl:=fom_sol;
       end else begin
         i20_suppl:=crysum[numero_sol_crysfire].i20;
         vv_suppl:=crysum[numero_sol_crysfire].vv1;
         fom_suppl:=crysum[numero_sol_crysfire].fom;
       end;
       str(numero_sol_crysfire:4,s2);
       str(i20_suppl:3,s1);
       s2:=s2+s1;
       str(fom_suppl:8:2,s1);
       s2:=s2+s1;
       str(vv_suppl:5:2,s1);
       s2:=s2+s1;
       if (numero_sol_crysfire <> listbox1.itemIndex) then
       fsupple.listbox4.items.add(s2+' '+s) else continue;

       if (vv1 < 10000)then str(vv1:6:2,s1) else str(vv1:6:1,s1);
       s:=s+s1;
       s:=psys+s;
       s:=s+' '+sm;
       if (numero_sol_crysfire > 0)then begin
         str(numero_sol_crysfire:2,s1);
         s:=s+s1;
       end;
       listbox2.items.add(s);
       nb_lignes:=nb_lignes+1;
       nb_sol:=nb_sol+1;
       for k:=1 to 6 do solutions[nb_sol,k]:=maille[k];
     end;
   end;
  end;
  closefile(nomf);

//Pas de solutions
  if (nb_sol = 1)then begin
    beep;
    listbox2.items.add('No cell');
       nb_lignes:=nb_lignes+1;
    screen.cursor:=CRDefault;
    exit;
  end;

//Etablissement de la structure crysum_truecel
 //  assignfile(nomf,'espion.txt');
//   rewrite(nomf);
   for i:=1 to nb_sol do begin
     s:=fsupple.listbox4.items[i-1];
     dec(s,maille2,no,ier);
     with crysum_truecell[i] do begin
       liste:=s;
//       writeln(nomf,s);
       num:=round(maille2[1]);
       i20:=round(maille2[2]);
       fom:=maille2[3];
       vv1:=maille2[4];
       no_truecell:=i;
       for j:=1 to 6 do begin
         maille[j]:=maille2[j+4];
         cel[j]:=maille2[j+4];
       end;
       quel_systeme;
       syst:=systeme;
       vol:=maille2[11];
     end;
   end;
//   closefile(nomf);

  color95button1.visible:=true;
  screen.cursor:=CRDefault;

end;

procedure Tflepage.sortie(Sender: TObject);
//----------------------------------------
begin
  close;
end;

procedure Tflepage.initialise(Sender: TObject);
//---------------------------------------------
var
   i               : integer;
begin
  listbox1.clear;
  nb_lignes:=0;
  no_ligne:=-1;
  //listbox2.clear;
  memo3.clear;
  color95button1.visible:=false;
  for i:=0 to nb_sol_crysfire do
  listbox1.Items.Add(form1.listbox4.Items[i]);
  listbox1.itemIndex:=1;
  checklistbox1.State[0]:=cbchecked;
  for i:=1 to 6 do checklistbox1.State[i]:=cbunchecked;
  checklistbox1.itemindex:=0;
  listbox6.clear;
  listbox6.items.add(
  'Syst.   A      B      C    Alpha  Beta   Gamma    V     V/V1'+
  '                  Transformation Matrix                 Nb');

end;

procedure Tflepage.edit_print(Sender: TObject);
//---------------------------------------------
var
    CmdFile      : Pchar;
    iwin,i       : integer;
    nomf         : TextFile;
begin
  if (nb_sol = 0)then exit;
  assignFile(nomf,'lepage.tmp');
  rewrite(nomf);
  writeln(nomf,'Initial cell');
//  writeln(nomf,listbox2.items[0]);
  writeln(nomf,memo3.lines[0]);
  writeln(nomf,memo3.lines[2]);

  writeln(nomf);
  writeln(nomf,'Found cell(s)');
  writeln(nomf,listbox6.items[0]);
  for i:=1 to nb_sol-1 do writeln(nomf,listbox2.items[i-1]);
  CloseFile(nomf);
  CmdFile:='write.exe lepage.tmp';
  iwin:=WinExec(CmdFile,5);

end;

procedure Tflepage.on_click_checklist(Sender: TObject);
//-----------------------------------------------------
var
  i                : integer;
begin
  with checklistbox1 do begin
    if (itemindex = 0) then begin
      for i:=1 to 6 do state[i]:=cbunchecked;
      state[0]:=cbchecked;
    end else begin
      state[0]:=cbunchecked;
    end;
    listbox2.clear;
  end;
end;

procedure Tflepage.on_change(Sender: TObject);
//-------------------------------------------
begin
  memo3.Clear;
  listbox2.clear;
  color95button1.visible:=false;
end;

procedure Tflepage.on_click_listbox1(Sender: TObject);
//----------------------------------------------------
begin
  color95button1.visible:=false;
end;

procedure Tflepage.Color95Button1Click(Sender: TObject);
//------------------------------------------------------
begin
  //nb_sol:=nb_sol+1;
  fsupple.visible:=true;
end;

procedure Tflepage.BitBtn5Click(Sender: TObject);
//------------------------------------------------
var
   s               : string;
   maille          : tab_reel;
   no,ier,i        : integer;
begin
    if (listbox1.itemIndex = -1)then exit;
    s:=listbox1.items[listbox1.itemIndex];
    dec(s,maille,no,ier);
    fom_sol:=maille[3];
    for i:=1 to 6 do begin
      cel[i]:=maille[i+4];
      cel_depart[i]:=maille[i+4];
    end;
    quel_systeme;
    listbox1.itemindex:=-1;
    fsupercell.bitbtn2.visible:=false;
    //fsupercell.bitbtn4.visible:=false; Bouton ADD
    fsupercell.visible:=true;
end;
(*
procedure Tflepage.BitBtn2Click(Sender: TObject);
//-----------------------------------------------
 var
   s               : string;
   maille          : tab_reel;
   no,ier,i,x,y    : integer;
begin
    if (nb_lignes <=0)then exit;
    //posxy(memo2,x,y);
    if(no_ligne = -1) or (no_ligne > nb_lignes) then begin
      exit;
    end;
    s:=memo2.lines[y];
    systeme:=trim(copy(s,1,4));
    delete(s,1,4);
    s:=trim(s);
    dec(s,maille,no,ier);
    for i:=1 to 6 do cel[i]:=maille[i];
    //listbox4.itemindex:=-1;
    fsupercell.bitbtn2.visible:=false;
//  fsupercell.bitbtn4.visible:=false;
    fsupercell.visible:=true;

end;

procedure Tflepage.selecte_ligne(Sender: TObject);
//-----------------------------------------------
var
  x : integer;
begin
  posxy(memo2,x,no_ligne);
end;
    *)
procedure Tflepage.BitBtn2Click(Sender: TObject);
//-----------------------------------------------
 var
   s               : string;
   maille          : tab_reel;
   no,ier,i        : integer;
begin
    if (listbox2.itemIndex = -1)then begin
      beep;
      erreur('No solution selected');
      exit;
    end;
    s:=listbox2.items[listbox2.itemIndex];
    systeme:=trim(copy(s,1,4));
    delete(s,1,4);
    s:=trim(s);
    dec(s,maille,no,ier);
    for i:=1 to 6 do cel[i]:=maille[i];
    listbox2.itemindex:=-1;
    fsupercell.bitbtn2.visible:=false;
    fsupercell.visible:=true;
end;

procedure Tflepage.calcul_densite(Sender: TObject);
//------------------------------------------------
var
  i    : integer;
  s    : string;
begin
  if (nb_sol <= 0) then begin
      beep;
      erreur('No cell');
      exit;
  end;
  form70.visible:=true;
  form70.listbox1.clear;
  form70.Label14.caption:='';
  s:='Syst.   a      b      c    alpha  beta   gamma     V ';
  form70.listbox1.items.add(s);
  for i:=0 to nb_sol-2 do begin
    s:=copy(listbox2.items[i],1,54);
    form70.listbox1.items.add(s);
  end;
  nombre_mailles:=nb_sol-1;
  provenance:='lepage';
end;


end.
